<?php
if (!defined('BB_ROOT')) die(basename(__FILE__));

class Chat
{
	function auth ($type, $group_id, $ug_data, $f_access = array(), $default = false)
	{
		global $lang, $bf, $datastore;

		$is_guest = true;
		$is_admin = false;
		$auth = $auth_fields = $u_access = array();
		$add_auth_type_desc = ($group_id != AUTH_LIST_ALL || $default);

		if ($type == AUTH_ALL)
		{
			$auth_fields = array_keys($bf['group_chat_perm']);
		}
		else if ($auth_type = array_search($type, $bf['group_chat_perm']))
		{
			$auth_fields = array($auth_type);
		}

		if (empty($auth_fields))
		{
			trigger_error(__FUNCTION__ .'(): empty $auth_fields', E_USER_ERROR);
		}

		if(!$default)
		{
			if (empty($f_access))
			{
				if (!$forums = $datastore->get('group_chat'))
				{
					$datastore->update('group_chat');
					$forums = $datastore->get('group_chat');
				}

				if ($group_id == AUTH_LIST_ALL)
				{
					$f_access = $forums['c'];
				}
				else if (isset($forums['c'][$group_id]))
				{
					$f_access[$group_id] = $forums['c'][$group_id];
				}
			}
			else if (isset($f_access['group_id']))
			{
				// Change passed $f_access format for later using in foreach()
				$f_access = array($f_access['group_id'] => $f_access);
			}


			if (empty($f_access))
			{
				trigger_error(__FUNCTION__ .'(): empty $f_access', E_USER_ERROR);
			}
		}else{
			$f_access = array($group_id => $f_access);
		}
		// GROUP mode
		if (!empty($ug_data['group_id']))
		{
			$is_guest = false;
			$is_admin = false;

			$sql = "SELECT g.*
				FROM ". BB_GROUPS ." g
				WHERE g.group_id = ". (int) $ug_data['group_id'] ."
					AND g.group_reed_chat = 1";

			foreach (DB()->fetch_rowset($sql) as $row)
			{
				$u_access[] = $row['group_id'];
			}
		}
		else if (!empty($ug_data['user_id']))
		{
			$is_guest = empty($ug_data['session_logged_in']);
			$is_admin = (!$is_guest && $ug_data['user_level'] == ADMIN);

		}
		
		foreach ($f_access as $f_id => $f_data)
		{
			$auth[$f_id]['group_chat_mod'] = auth_check('group_chat_perm', 'group_chat_mod', $u_access, $f_id, $is_admin);

			foreach ($auth_fields as $auth_type)
			{
				if (!isset($f_data[$auth_type]))
				{
					continue;
				}
				switch ($f_data[$auth_type])
				{
					case AUTH_ALL:
						$auth[$f_id][$auth_type] = true;
						break;

					case AUTH_REG:
						$auth[$f_id][$auth_type] = !$is_guest;
						break;

					case AUTH_ACL:
						$auth[$f_id][$auth_type] = (auth_check('group_chat_perm', $auth_type, $u_access, $f_id, $is_admin) || $auth[$f_id]['group_chat_mod']);
						break;

					case AUTH_MOD:
						$auth[$f_id][$auth_type] = $auth[$f_id]['group_chat_mod'];
						break;

					case AUTH_ADMIN:
						$auth[$f_id][$auth_type] = $is_admin;
						break;

					default:
						$auth[$f_id][$auth_type] = false;
				}
				if ($add_auth_type_desc)
				{
					$auth[$f_id][$auth_type .'_type'] =& $lang['AUTH_TYPES'][$f_data[$auth_type]];
				}
			}
		}
		if($default)
		{
			return $auth[$group_id];
		}else{
			return ($group_id == AUTH_LIST_ALL) ? $auth : $auth[$group_id];
		}	
	}

	function renumber_order($mode, $cat = 0)
	{
		switch($mode)
		{
			case 'category':
				$table = BB_CHAT_GROUP;
				$idfield = 'group_id';
				$orderfield = 'group_order';
				$cat = 0;
				break;

			default:
				message_die(GENERAL_ERROR, "Wrong mode for generating select list", "", __LINE__, __FILE__);
				break;
		}

		$sql = "SELECT * FROM $table";
		if( !empty($cat) )
		{
			$sql .= " WHERE $catfield = $cat";
		}
		$sql .= " ORDER BY $orderfield ASC";


		if( !$result = DB()->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, "Couldn't get list of Categories", "", __LINE__, __FILE__, $sql);
		}

		$i = 10;
		$inc = 10;

		while( $row = DB()->sql_fetchrow($result) )
		{
			$sql = "UPDATE $table
				SET $orderfield = $i
				WHERE $idfield = " . $row[$idfield];
			if( !DB()->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, "Couldn't update order fields", "", __LINE__, __FILE__, $sql);
			}
			$i += 10;
		}

	}
	
	function get_info($id)
	{
		$sql = "SELECT count(*) as total
			FROM ".BB_CHAT_GROUP."";
		if( !$result = DB()->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, "Couldn't get Forum/Category information", "", __LINE__, __FILE__, $sql);
		}
		$count = DB()->sql_fetchrow($result);
		$count = $count['total'];

		$sql = "SELECT *
			FROM ".BB_CHAT_GROUP."
			WHERE group_id = $id";

		if( !$result = DB()->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, "Couldn't get Forum/Category information", "", __LINE__, __FILE__, $sql);
		}

		if( DB()->num_rows($result) != 1 )
		{
			message_die(GENERAL_ERROR, "Forum/Category doesn't exist or multiple forums/categories with ID $id", "", __LINE__, __FILE__);
		}

		$return = DB()->sql_fetchrow($result);
		$return['number'] = $count;
		return $return;
	}

	function get_cat ($cat_id = FALSE)
	{
		$forums = array();
		$where_sql = '';
		
		if ($cat_id = intval($cat_id))
		{
			$where_sql = "AND group_id = $cat_id";
		}

		$sql = 'SELECT *
			FROM '. BB_CHAT_GROUP ."
				$where_sql
			ORDER BY group_order, group_id";

		if (!$result = DB()->sql_query($sql))
		{
			message_die(GENERAL_ERROR, "Couldn't get list of Categories", "", __LINE__, __FILE__, $sql);
		}

		if ($rowset = DB()->sql_fetchrowset($result))
		{
			foreach ($rowset as $rid => $row)
			{
				$forums[$row['group_id']]['group_name'] = $row['group_name'];
				$forums[$row['group_id']]['f'][$row['group_id']] = $row;
				$forums[$row['group_id']]['f_ord'][$row['group_order']] = $row;
			}
		}

		return $forums;
	}

	function get_orphan_sf ()
	{
		global $cat_forums;

		$last_root = 0;
		$bad_sf_ary = array();

		foreach ($cat_forums as $cid => $c)
		{
			foreach ($c['f'] as $fid => $f)
			{
					$last_root = $f['group_id'];
			}
		}

		return implode(',', $bad_sf_ary);
	}
}

